/*
 =================== DO NOT EDIT THIS FILE ====================
 Generated by Modello 1.4.1 on 2011-03-10 13:27:53,
 any modifications will be overwritten.
 ==============================================================
 */

package org.apache.maven.artifact.repository.metadata.io.jdom;

  //---------------------------------/
 //- Imported classes and packages -/
//---------------------------------/

import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.Writer;
import java.text.DateFormat;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;
import java.util.ListIterator;
import java.util.Locale;
import java.util.Map;
import java.util.Properties;
import org.apache.maven.artifact.repository.metadata.Metadata;
import org.apache.maven.artifact.repository.metadata.Plugin;
import org.apache.maven.artifact.repository.metadata.Snapshot;
import org.apache.maven.artifact.repository.metadata.SnapshotVersion;
import org.apache.maven.artifact.repository.metadata.Versioning;
import org.jdom.Content;
import org.jdom.DefaultJDOMFactory;
import org.jdom.Document;
import org.jdom.Element;
import org.jdom.Text;
import org.jdom.output.Format;
import org.jdom.output.XMLOutputter;

/**
 * Class MetadataJDOMWriter.
 * 
 * @version $Revision$ $Date$
 */
@SuppressWarnings( "all" )
public class MetadataJDOMWriter
{

      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * Field factory.
     */
    private DefaultJDOMFactory factory;

    /**
     * Field lineSeparator.
     */
    private String lineSeparator;


      //----------------/
     //- Constructors -/
    //----------------/

    public MetadataJDOMWriter()
    {
        factory = new DefaultJDOMFactory();
        lineSeparator = "\n";
    } //-- org.apache.maven.artifact.repository.metadata.io.jdom.MetadataJDOMWriter()


      //-----------/
     //- Methods -/
    //-----------/

    /**
     * Method findAndReplaceProperties.
     * 
     * @param counter
     * @param props
     * @param name
     * @param parent
     * @return Element
     */
    protected Element findAndReplaceProperties( Counter counter, Element parent, String name, Map props )
    {
        boolean shouldExist = ( props != null ) && ! props.isEmpty();
        Element element = updateElement( counter, parent, name, shouldExist );
        if ( shouldExist )
        {
            Iterator it = props.keySet().iterator();
            Counter innerCounter = new Counter( counter.getDepth() + 1 );
            while ( it.hasNext() )
            {
                String key = (String) it.next();
                findAndReplaceSimpleElement( innerCounter, element, key, (String) props.get( key ), null );
            }
            ArrayList lst = new ArrayList( props.keySet() );
            it = element.getChildren().iterator();
            while ( it.hasNext() )
            {
                Element elem = (Element) it.next();
                String key = elem.getName();
                if ( !lst.contains( key ) )
                {
                    it.remove();
                }
            }
        }
        return element;
    } //-- Element findAndReplaceProperties( Counter, Element, String, Map )

    /**
     * Method findAndReplaceSimpleElement.
     * 
     * @param counter
     * @param defaultValue
     * @param text
     * @param name
     * @param parent
     * @return Element
     */
    protected Element findAndReplaceSimpleElement( Counter counter, Element parent, String name, String text, String defaultValue )
    {
        if ( ( defaultValue != null ) && ( text != null ) && defaultValue.equals( text ) )
        {
            Element element =  parent.getChild( name, parent.getNamespace() );
            // if exist and is default value or if doesn't exist.. just keep the way it is..
            if ( ( element != null && defaultValue.equals( element.getText() ) ) || element == null )
            {
                return element;
            }
        }
        boolean shouldExist = ( text != null ) && ( text.trim().length() > 0 );
        Element element = updateElement( counter, parent, name, shouldExist );
        if ( shouldExist )
        {
            element.setText( text );
        }
        return element;
    } //-- Element findAndReplaceSimpleElement( Counter, Element, String, String, String )

    /**
     * Method findAndReplaceSimpleLists.
     * 
     * @param counter
     * @param childName
     * @param parentName
     * @param list
     * @param parent
     * @return Element
     */
    protected Element findAndReplaceSimpleLists( Counter counter, Element parent, java.util.Collection list, String parentName, String childName )
    {
        boolean shouldExist = ( list != null ) && ( list.size() > 0 );
        Element element = updateElement( counter, parent, parentName, shouldExist );
        if ( shouldExist )
        {
            Iterator it = list.iterator();
            Iterator elIt = element.getChildren( childName, element.getNamespace() ).iterator();
            if ( ! elIt.hasNext() )
            {
                 elIt = null;
            }
            Counter innerCount = new Counter( counter.getDepth() + 1 );
            while ( it.hasNext() )
            {
                String value = (String) it.next();
                Element el;
                if ( elIt != null && elIt.hasNext() )
                {
                    el = (Element) elIt.next();
                    if ( ! elIt.hasNext() )
                    {
                        elIt = null;
                    }
                }
                else
                {
                    el = factory.element( childName, element.getNamespace() );
                    insertAtPreferredLocation( element, el, innerCount );
                }
                el.setText( value );
                innerCount.increaseCount();
            }
            if ( elIt != null )
            {
                while ( elIt.hasNext() )
                {
                    elIt.next();
                    elIt.remove();
                }
            }
        }
        return element;
    } //-- Element findAndReplaceSimpleLists( Counter, Element, java.util.Collection, String, String )

    /**
     * Method insertAtPreferredLocation.
     * 
     * @param parent
     * @param counter
     * @param child
     */
    protected void insertAtPreferredLocation( Element parent, Element child, Counter counter )
    {
        int contentIndex = 0;
        int elementCounter = 0;
        Iterator it = parent.getContent().iterator();
        Text lastText = null;
        int offset = 0;
        while ( it.hasNext() && elementCounter <= counter.getCurrentIndex() )
        {
            Object next = it.next();
            offset = offset + 1;
            if ( next instanceof Element )
            {
                elementCounter = elementCounter + 1;
                contentIndex = contentIndex + offset;
                offset = 0;
            }
            if ( next instanceof Text && it.hasNext() )
            {
                lastText = (Text) next;
            }
        }
        if ( lastText != null && lastText.getTextTrim().length() == 0 )
        {
            lastText = (Text) lastText.clone();
        }
        else
        {
            String starter = lineSeparator;
            for ( int i = 0; i < counter.getDepth(); i++ )
            {
                starter = starter + "    "; //TODO make settable?
            }
            lastText = factory.text( starter );
        }
        if ( parent.getContentSize() == 0 )
        {
            Text finalText = (Text) lastText.clone();
            finalText.setText( finalText.getText().substring( 0, finalText.getText().length() - "    ".length() ) );
            parent.addContent( contentIndex, finalText );
        }
        parent.addContent( contentIndex, child );
        parent.addContent( contentIndex, lastText );
    } //-- void insertAtPreferredLocation( Element, Element, Counter )

    /**
     * Method iteratePlugin.
     * 
     * @param counter
     * @param childTag
     * @param parentTag
     * @param list
     * @param parent
     */
    protected void iteratePlugin( Counter counter, Element parent, java.util.Collection list, java.lang.String parentTag, java.lang.String childTag )
    {
        boolean shouldExist = ( list != null ) && ( list.size() > 0 );
        Element element = updateElement( counter, parent, parentTag, shouldExist );
        if ( shouldExist )
        {
            Iterator it = list.iterator();
            Iterator elIt = element.getChildren( childTag, element.getNamespace() ).iterator();
            if ( !elIt.hasNext() )
            {
                elIt = null;
            }
            Counter innerCount = new Counter( counter.getDepth() + 1 );
            while ( it.hasNext() )
            {
                Plugin value = (Plugin) it.next();
                Element el;
                if ( elIt != null && elIt.hasNext() )
                {
                    el = (Element) elIt.next();
                    if ( ! elIt.hasNext() )
                    {
                         elIt = null;
                    }
                }
                else
                {
                    el = factory.element( childTag, element.getNamespace() );
                    insertAtPreferredLocation( element, el, innerCount );
                }
                updatePlugin( value, childTag, innerCount, el );
                innerCount.increaseCount();
            }
            if ( elIt != null )
            {
                while ( elIt.hasNext() )
                {
                    elIt.next();
                    elIt.remove();
                }
            }
        }
    } //-- void iteratePlugin( Counter, Element, java.util.Collection, java.lang.String, java.lang.String )

    /**
     * Method iterateSnapshotVersion.
     * 
     * @param counter
     * @param childTag
     * @param parentTag
     * @param list
     * @param parent
     */
    protected void iterateSnapshotVersion( Counter counter, Element parent, java.util.Collection list, java.lang.String parentTag, java.lang.String childTag )
    {
        boolean shouldExist = ( list != null ) && ( list.size() > 0 );
        Element element = updateElement( counter, parent, parentTag, shouldExist );
        if ( shouldExist )
        {
            Iterator it = list.iterator();
            Iterator elIt = element.getChildren( childTag, element.getNamespace() ).iterator();
            if ( !elIt.hasNext() )
            {
                elIt = null;
            }
            Counter innerCount = new Counter( counter.getDepth() + 1 );
            while ( it.hasNext() )
            {
                SnapshotVersion value = (SnapshotVersion) it.next();
                Element el;
                if ( elIt != null && elIt.hasNext() )
                {
                    el = (Element) elIt.next();
                    if ( ! elIt.hasNext() )
                    {
                         elIt = null;
                    }
                }
                else
                {
                    el = factory.element( childTag, element.getNamespace() );
                    insertAtPreferredLocation( element, el, innerCount );
                }
                updateSnapshotVersion( value, childTag, innerCount, el );
                innerCount.increaseCount();
            }
            if ( elIt != null )
            {
                while ( elIt.hasNext() )
                {
                    elIt.next();
                    elIt.remove();
                }
            }
        }
    } //-- void iterateSnapshotVersion( Counter, Element, java.util.Collection, java.lang.String, java.lang.String )

    /**
     * Method updateElement.
     * 
     * @param counter
     * @param shouldExist
     * @param name
     * @param parent
     * @return Element
     */
    protected Element updateElement( Counter counter, Element parent, String name, boolean shouldExist )
    {
        Element element =  parent.getChild( name, parent.getNamespace() );
        if ( shouldExist )
        {
            if ( element == null )
            {
                element = factory.element( name, parent.getNamespace() );
                insertAtPreferredLocation( parent, element, counter );
            }
            counter.increaseCount();
        }
        else if ( element != null )
        {
            int index = parent.indexOf( element );
            if ( index > 0 )
            {
                Content previous = parent.getContent( index - 1 );
                if ( previous instanceof Text )
                {
                    Text txt = (Text) previous;
                    if ( txt.getTextTrim().length() == 0 )
                    {
                        parent.removeContent( txt );
                    }
                }
            }
            parent.removeContent( element );
        }
        return element;
    } //-- Element updateElement( Counter, Element, String, boolean )

    /**
     * Method updateMetadata.
     * 
     * @param metadata
     * @param element
     * @param counter
     * @param xmlTag
     */
    protected void updateMetadata( Metadata metadata, String xmlTag, Counter counter, Element element )
    {
        Element root = element;
        Counter innerCount = new Counter( counter.getDepth() + 1 );
        findAndReplaceSimpleElement( innerCount, root, "groupId", metadata.getGroupId() == null ? null : metadata.getGroupId(), null );
        findAndReplaceSimpleElement( innerCount, root, "artifactId", metadata.getArtifactId() == null ? null : metadata.getArtifactId(), null );
        findAndReplaceSimpleElement( innerCount, root, "version", metadata.getVersion() == null ? null : metadata.getVersion(), null );
        updateVersioning( metadata.getVersioning(), "versioning", innerCount, root );
        iteratePlugin( innerCount, root, metadata.getPlugins(),"plugins","plugin" );
    } //-- void updateMetadata( Metadata, String, Counter, Element )

    /**
     * Method updatePlugin.
     * 
     * @param plugin
     * @param element
     * @param counter
     * @param xmlTag
     */
    protected void updatePlugin( Plugin plugin, String xmlTag, Counter counter, Element element )
    {
        Element root = element;
        Counter innerCount = new Counter( counter.getDepth() + 1 );
        findAndReplaceSimpleElement( innerCount, root, "name", plugin.getName() == null ? null : plugin.getName(), null );
        findAndReplaceSimpleElement( innerCount, root, "prefix", plugin.getPrefix() == null ? null : plugin.getPrefix(), null );
        findAndReplaceSimpleElement( innerCount, root, "artifactId", plugin.getArtifactId() == null ? null : plugin.getArtifactId(), null );
    } //-- void updatePlugin( Plugin, String, Counter, Element )

    /**
     * Method updateSnapshot.
     * 
     * @param snapshot
     * @param element
     * @param counter
     * @param xmlTag
     */
    protected void updateSnapshot( Snapshot snapshot, String xmlTag, Counter counter, Element element )
    {
        boolean shouldExist = ( snapshot != null );
        Element root = updateElement( counter, element, xmlTag, shouldExist );
        if ( shouldExist )
        {
            Counter innerCount = new Counter( counter.getDepth() + 1 );
            findAndReplaceSimpleElement( innerCount, root, "timestamp", snapshot.getTimestamp() == null ? null : snapshot.getTimestamp(), null );
            findAndReplaceSimpleElement( innerCount, root, "buildNumber", snapshot.getBuildNumber() == 0 ? null : String.valueOf( snapshot.getBuildNumber() ), "0" );
            findAndReplaceSimpleElement( innerCount, root, "localCopy", snapshot.isLocalCopy() == false ? null : String.valueOf( snapshot.isLocalCopy() ), "false" );
        }
    } //-- void updateSnapshot( Snapshot, String, Counter, Element )

    /**
     * Method updateSnapshotVersion.
     * 
     * @param snapshotVersion
     * @param element
     * @param counter
     * @param xmlTag
     */
    protected void updateSnapshotVersion( SnapshotVersion snapshotVersion, String xmlTag, Counter counter, Element element )
    {
        Element root = element;
        Counter innerCount = new Counter( counter.getDepth() + 1 );
        findAndReplaceSimpleElement( innerCount, root, "classifier", snapshotVersion.getClassifier() == null ? null : snapshotVersion.getClassifier(), "" );
        findAndReplaceSimpleElement( innerCount, root, "extension", snapshotVersion.getExtension() == null ? null : snapshotVersion.getExtension(), null );
        findAndReplaceSimpleElement( innerCount, root, "value", snapshotVersion.getVersion() == null ? null : snapshotVersion.getVersion(), null );
        findAndReplaceSimpleElement( innerCount, root, "updated", snapshotVersion.getUpdated() == null ? null : snapshotVersion.getUpdated(), null );
    } //-- void updateSnapshotVersion( SnapshotVersion, String, Counter, Element )

    /**
     * Method updateVersioning.
     * 
     * @param versioning
     * @param element
     * @param counter
     * @param xmlTag
     */
    protected void updateVersioning( Versioning versioning, String xmlTag, Counter counter, Element element )
    {
        boolean shouldExist = ( versioning != null );
        Element root = updateElement( counter, element, xmlTag, shouldExist );
        if ( shouldExist )
        {
            Counter innerCount = new Counter( counter.getDepth() + 1 );
            findAndReplaceSimpleElement( innerCount, root, "latest", versioning.getLatest() == null ? null : versioning.getLatest(), null );
            findAndReplaceSimpleElement( innerCount, root, "release", versioning.getRelease() == null ? null : versioning.getRelease(), null );
            updateSnapshot( versioning.getSnapshot(), "snapshot", innerCount, root );
            findAndReplaceSimpleLists( innerCount, root, versioning.getVersions(), "versions", "version" );
            findAndReplaceSimpleElement( innerCount, root, "lastUpdated", versioning.getLastUpdated() == null ? null : versioning.getLastUpdated(), null );
            iterateSnapshotVersion( innerCount, root, versioning.getSnapshotVersions(),"snapshotVersions","snapshotVersion" );
        }
    } //-- void updateVersioning( Versioning, String, Counter, Element )

    /**
     * Method write.
     * @deprecated
     * 
     * @param metadata
     * @param stream
     * @param document
     * @throws java.io.IOException
     */
    public void write( Metadata metadata, Document document, OutputStream stream )
        throws java.io.IOException
    {
        updateMetadata( metadata, "metadata", new Counter( 0 ), document.getRootElement() );
        XMLOutputter outputter = new XMLOutputter();
        outputter.setFormat( Format.getPrettyFormat()
            .setIndent( "    " )
            .setLineSeparator( System.getProperty( "line.separator" ) ) );
        outputter.output( document, stream );
    } //-- void write( Metadata, Document, OutputStream )

    /**
     * Method write.
     * 
     * @param metadata
     * @param writer
     * @param document
     * @throws java.io.IOException
     */
    public void write( Metadata metadata, Document document, OutputStreamWriter writer )
        throws java.io.IOException
    {
        Format format = Format.getRawFormat()
            .setEncoding( writer.getEncoding() )
            .setLineSeparator( System.getProperty( "line.separator" ) );
        write( metadata, document, writer, format );
    } //-- void write( Metadata, Document, OutputStreamWriter )

    /**
     * Method write.
     * 
     * @param metadata
     * @param jdomFormat
     * @param writer
     * @param document
     * @throws java.io.IOException
     */
    public void write( Metadata metadata, Document document, Writer writer, Format jdomFormat )
        throws java.io.IOException
    {
        updateMetadata( metadata, "metadata", new Counter( 0 ), document.getRootElement() );
        XMLOutputter outputter = new XMLOutputter();
        outputter.setFormat( jdomFormat );
        outputter.output( document, writer );
    } //-- void write( Metadata, Document, Writer, Format )


      //-----------------/
     //- Inner Classes -/
    //-----------------/

    /**
     * Class Counter.
     * 
     * @version $Revision$ $Date$
     */
    public class Counter
    {

          //--------------------------/
         //- Class/Member Variables -/
        //--------------------------/

        /**
         * Field currentIndex.
         */
        private int currentIndex = 0;

        /**
         * Field level.
         */
        private int level;


          //----------------/
         //- Constructors -/
        //----------------/

        public Counter(int depthLevel)
        {
            level = depthLevel;
        } //-- org.apache.maven.artifact.repository.metadata.io.jdom.Counter(int)


          //-----------/
         //- Methods -/
        //-----------/

        /**
         * Method getCurrentIndex.
         * 
         * @return int
         */
        public int getCurrentIndex()
        {
            return currentIndex;
        } //-- int getCurrentIndex()

        /**
         * Method getDepth.
         * 
         * @return int
         */
        public int getDepth()
        {
            return level;
        } //-- int getDepth()

        /**
         * Method increaseCount.
         */
        public void increaseCount()
        {
            currentIndex = currentIndex + 1;
        } //-- void increaseCount()

    }

}
