/*
 =================== DO NOT EDIT THIS FILE ====================
 Generated by Modello 1.4.1 on 2011-03-10 13:27:53,
 any modifications will be overwritten.
 ==============================================================
 */

package org.apache.maven.settings.io.jdom;

  //---------------------------------/
 //- Imported classes and packages -/
//---------------------------------/

import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.Writer;
import java.text.DateFormat;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;
import java.util.ListIterator;
import java.util.Locale;
import java.util.Map;
import java.util.Properties;
import org.apache.maven.settings.Activation;
import org.apache.maven.settings.ActivationFile;
import org.apache.maven.settings.ActivationOS;
import org.apache.maven.settings.ActivationProperty;
import org.apache.maven.settings.IdentifiableBase;
import org.apache.maven.settings.Mirror;
import org.apache.maven.settings.Profile;
import org.apache.maven.settings.Proxy;
import org.apache.maven.settings.Repository;
import org.apache.maven.settings.RepositoryBase;
import org.apache.maven.settings.RepositoryPolicy;
import org.apache.maven.settings.Server;
import org.apache.maven.settings.Settings;
import org.apache.maven.settings.TrackableBase;
import org.codehaus.plexus.util.xml.Xpp3Dom;
import org.jdom.Content;
import org.jdom.DefaultJDOMFactory;
import org.jdom.Document;
import org.jdom.Element;
import org.jdom.Text;
import org.jdom.output.Format;
import org.jdom.output.XMLOutputter;

/**
 * Class SettingsJDOMWriter.
 * 
 * @version $Revision$ $Date$
 */
@SuppressWarnings( "all" )
public class SettingsJDOMWriter
{

      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * Field factory.
     */
    private DefaultJDOMFactory factory;

    /**
     * Field lineSeparator.
     */
    private String lineSeparator;


      //----------------/
     //- Constructors -/
    //----------------/

    public SettingsJDOMWriter()
    {
        factory = new DefaultJDOMFactory();
        lineSeparator = "\n";
    } //-- org.apache.maven.settings.io.jdom.SettingsJDOMWriter()


      //-----------/
     //- Methods -/
    //-----------/

    /**
     * Method findAndReplaceProperties.
     * 
     * @param counter
     * @param props
     * @param name
     * @param parent
     * @return Element
     */
    protected Element findAndReplaceProperties( Counter counter, Element parent, String name, Map props )
    {
        boolean shouldExist = ( props != null ) && ! props.isEmpty();
        Element element = updateElement( counter, parent, name, shouldExist );
        if ( shouldExist )
        {
            Iterator it = props.keySet().iterator();
            Counter innerCounter = new Counter( counter.getDepth() + 1 );
            while ( it.hasNext() )
            {
                String key = (String) it.next();
                findAndReplaceSimpleElement( innerCounter, element, key, (String) props.get( key ), null );
            }
            ArrayList lst = new ArrayList( props.keySet() );
            it = element.getChildren().iterator();
            while ( it.hasNext() )
            {
                Element elem = (Element) it.next();
                String key = elem.getName();
                if ( !lst.contains( key ) )
                {
                    it.remove();
                }
            }
        }
        return element;
    } //-- Element findAndReplaceProperties( Counter, Element, String, Map )

    /**
     * Method findAndReplaceSimpleElement.
     * 
     * @param counter
     * @param defaultValue
     * @param text
     * @param name
     * @param parent
     * @return Element
     */
    protected Element findAndReplaceSimpleElement( Counter counter, Element parent, String name, String text, String defaultValue )
    {
        if ( ( defaultValue != null ) && ( text != null ) && defaultValue.equals( text ) )
        {
            Element element =  parent.getChild( name, parent.getNamespace() );
            // if exist and is default value or if doesn't exist.. just keep the way it is..
            if ( ( element != null && defaultValue.equals( element.getText() ) ) || element == null )
            {
                return element;
            }
        }
        boolean shouldExist = ( text != null ) && ( text.trim().length() > 0 );
        Element element = updateElement( counter, parent, name, shouldExist );
        if ( shouldExist )
        {
            element.setText( text );
        }
        return element;
    } //-- Element findAndReplaceSimpleElement( Counter, Element, String, String, String )

    /**
     * Method findAndReplaceSimpleLists.
     * 
     * @param counter
     * @param childName
     * @param parentName
     * @param list
     * @param parent
     * @return Element
     */
    protected Element findAndReplaceSimpleLists( Counter counter, Element parent, java.util.Collection list, String parentName, String childName )
    {
        boolean shouldExist = ( list != null ) && ( list.size() > 0 );
        Element element = updateElement( counter, parent, parentName, shouldExist );
        if ( shouldExist )
        {
            Iterator it = list.iterator();
            Iterator elIt = element.getChildren( childName, element.getNamespace() ).iterator();
            if ( ! elIt.hasNext() )
            {
                 elIt = null;
            }
            Counter innerCount = new Counter( counter.getDepth() + 1 );
            while ( it.hasNext() )
            {
                String value = (String) it.next();
                Element el;
                if ( elIt != null && elIt.hasNext() )
                {
                    el = (Element) elIt.next();
                    if ( ! elIt.hasNext() )
                    {
                        elIt = null;
                    }
                }
                else
                {
                    el = factory.element( childName, element.getNamespace() );
                    insertAtPreferredLocation( element, el, innerCount );
                }
                el.setText( value );
                innerCount.increaseCount();
            }
            if ( elIt != null )
            {
                while ( elIt.hasNext() )
                {
                    elIt.next();
                    elIt.remove();
                }
            }
        }
        return element;
    } //-- Element findAndReplaceSimpleLists( Counter, Element, java.util.Collection, String, String )

    /**
     * Method findAndReplaceXpp3DOM.
     * 
     * @param counter
     * @param dom
     * @param name
     * @param parent
     * @return Element
     */
    protected Element findAndReplaceXpp3DOM( Counter counter, Element parent, String name, Xpp3Dom dom )
    {
        boolean shouldExist = ( dom != null ) && ( dom.getChildCount() > 0 || dom.getValue() != null );
        Element element = updateElement( counter, parent, name, shouldExist );
        if ( shouldExist )
        {
            replaceXpp3DOM( element, dom, new Counter( counter.getDepth() + 1 ) );
        }
        return element;
    } //-- Element findAndReplaceXpp3DOM( Counter, Element, String, Xpp3Dom )

    /**
     * Method insertAtPreferredLocation.
     * 
     * @param parent
     * @param counter
     * @param child
     */
    protected void insertAtPreferredLocation( Element parent, Element child, Counter counter )
    {
        int contentIndex = 0;
        int elementCounter = 0;
        Iterator it = parent.getContent().iterator();
        Text lastText = null;
        int offset = 0;
        while ( it.hasNext() && elementCounter <= counter.getCurrentIndex() )
        {
            Object next = it.next();
            offset = offset + 1;
            if ( next instanceof Element )
            {
                elementCounter = elementCounter + 1;
                contentIndex = contentIndex + offset;
                offset = 0;
            }
            if ( next instanceof Text && it.hasNext() )
            {
                lastText = (Text) next;
            }
        }
        if ( lastText != null && lastText.getTextTrim().length() == 0 )
        {
            lastText = (Text) lastText.clone();
        }
        else
        {
            String starter = lineSeparator;
            for ( int i = 0; i < counter.getDepth(); i++ )
            {
                starter = starter + "    "; //TODO make settable?
            }
            lastText = factory.text( starter );
        }
        if ( parent.getContentSize() == 0 )
        {
            Text finalText = (Text) lastText.clone();
            finalText.setText( finalText.getText().substring( 0, finalText.getText().length() - "    ".length() ) );
            parent.addContent( contentIndex, finalText );
        }
        parent.addContent( contentIndex, child );
        parent.addContent( contentIndex, lastText );
    } //-- void insertAtPreferredLocation( Element, Element, Counter )

    /**
     * Method iterateMirror.
     * 
     * @param counter
     * @param childTag
     * @param parentTag
     * @param list
     * @param parent
     */
    protected void iterateMirror( Counter counter, Element parent, java.util.Collection list, java.lang.String parentTag, java.lang.String childTag )
    {
        boolean shouldExist = ( list != null ) && ( list.size() > 0 );
        Element element = updateElement( counter, parent, parentTag, shouldExist );
        if ( shouldExist )
        {
            Iterator it = list.iterator();
            Iterator elIt = element.getChildren( childTag, element.getNamespace() ).iterator();
            if ( !elIt.hasNext() )
            {
                elIt = null;
            }
            Counter innerCount = new Counter( counter.getDepth() + 1 );
            while ( it.hasNext() )
            {
                Mirror value = (Mirror) it.next();
                Element el;
                if ( elIt != null && elIt.hasNext() )
                {
                    el = (Element) elIt.next();
                    if ( ! elIt.hasNext() )
                    {
                         elIt = null;
                    }
                }
                else
                {
                    el = factory.element( childTag, element.getNamespace() );
                    insertAtPreferredLocation( element, el, innerCount );
                }
                updateMirror( value, childTag, innerCount, el );
                innerCount.increaseCount();
            }
            if ( elIt != null )
            {
                while ( elIt.hasNext() )
                {
                    elIt.next();
                    elIt.remove();
                }
            }
        }
    } //-- void iterateMirror( Counter, Element, java.util.Collection, java.lang.String, java.lang.String )

    /**
     * Method iterateProfile.
     * 
     * @param counter
     * @param childTag
     * @param parentTag
     * @param list
     * @param parent
     */
    protected void iterateProfile( Counter counter, Element parent, java.util.Collection list, java.lang.String parentTag, java.lang.String childTag )
    {
        boolean shouldExist = ( list != null ) && ( list.size() > 0 );
        Element element = updateElement( counter, parent, parentTag, shouldExist );
        if ( shouldExist )
        {
            Iterator it = list.iterator();
            Iterator elIt = element.getChildren( childTag, element.getNamespace() ).iterator();
            if ( !elIt.hasNext() )
            {
                elIt = null;
            }
            Counter innerCount = new Counter( counter.getDepth() + 1 );
            while ( it.hasNext() )
            {
                Profile value = (Profile) it.next();
                Element el;
                if ( elIt != null && elIt.hasNext() )
                {
                    el = (Element) elIt.next();
                    if ( ! elIt.hasNext() )
                    {
                         elIt = null;
                    }
                }
                else
                {
                    el = factory.element( childTag, element.getNamespace() );
                    insertAtPreferredLocation( element, el, innerCount );
                }
                updateProfile( value, childTag, innerCount, el );
                innerCount.increaseCount();
            }
            if ( elIt != null )
            {
                while ( elIt.hasNext() )
                {
                    elIt.next();
                    elIt.remove();
                }
            }
        }
    } //-- void iterateProfile( Counter, Element, java.util.Collection, java.lang.String, java.lang.String )

    /**
     * Method iterateProxy.
     * 
     * @param counter
     * @param childTag
     * @param parentTag
     * @param list
     * @param parent
     */
    protected void iterateProxy( Counter counter, Element parent, java.util.Collection list, java.lang.String parentTag, java.lang.String childTag )
    {
        boolean shouldExist = ( list != null ) && ( list.size() > 0 );
        Element element = updateElement( counter, parent, parentTag, shouldExist );
        if ( shouldExist )
        {
            Iterator it = list.iterator();
            Iterator elIt = element.getChildren( childTag, element.getNamespace() ).iterator();
            if ( !elIt.hasNext() )
            {
                elIt = null;
            }
            Counter innerCount = new Counter( counter.getDepth() + 1 );
            while ( it.hasNext() )
            {
                Proxy value = (Proxy) it.next();
                Element el;
                if ( elIt != null && elIt.hasNext() )
                {
                    el = (Element) elIt.next();
                    if ( ! elIt.hasNext() )
                    {
                         elIt = null;
                    }
                }
                else
                {
                    el = factory.element( childTag, element.getNamespace() );
                    insertAtPreferredLocation( element, el, innerCount );
                }
                updateProxy( value, childTag, innerCount, el );
                innerCount.increaseCount();
            }
            if ( elIt != null )
            {
                while ( elIt.hasNext() )
                {
                    elIt.next();
                    elIt.remove();
                }
            }
        }
    } //-- void iterateProxy( Counter, Element, java.util.Collection, java.lang.String, java.lang.String )

    /**
     * Method iterateRepository.
     * 
     * @param counter
     * @param childTag
     * @param parentTag
     * @param list
     * @param parent
     */
    protected void iterateRepository( Counter counter, Element parent, java.util.Collection list, java.lang.String parentTag, java.lang.String childTag )
    {
        boolean shouldExist = ( list != null ) && ( list.size() > 0 );
        Element element = updateElement( counter, parent, parentTag, shouldExist );
        if ( shouldExist )
        {
            Iterator it = list.iterator();
            Iterator elIt = element.getChildren( childTag, element.getNamespace() ).iterator();
            if ( !elIt.hasNext() )
            {
                elIt = null;
            }
            Counter innerCount = new Counter( counter.getDepth() + 1 );
            while ( it.hasNext() )
            {
                Repository value = (Repository) it.next();
                Element el;
                if ( elIt != null && elIt.hasNext() )
                {
                    el = (Element) elIt.next();
                    if ( ! elIt.hasNext() )
                    {
                         elIt = null;
                    }
                }
                else
                {
                    el = factory.element( childTag, element.getNamespace() );
                    insertAtPreferredLocation( element, el, innerCount );
                }
                updateRepository( value, childTag, innerCount, el );
                innerCount.increaseCount();
            }
            if ( elIt != null )
            {
                while ( elIt.hasNext() )
                {
                    elIt.next();
                    elIt.remove();
                }
            }
        }
    } //-- void iterateRepository( Counter, Element, java.util.Collection, java.lang.String, java.lang.String )

    /**
     * Method iterateServer.
     * 
     * @param counter
     * @param childTag
     * @param parentTag
     * @param list
     * @param parent
     */
    protected void iterateServer( Counter counter, Element parent, java.util.Collection list, java.lang.String parentTag, java.lang.String childTag )
    {
        boolean shouldExist = ( list != null ) && ( list.size() > 0 );
        Element element = updateElement( counter, parent, parentTag, shouldExist );
        if ( shouldExist )
        {
            Iterator it = list.iterator();
            Iterator elIt = element.getChildren( childTag, element.getNamespace() ).iterator();
            if ( !elIt.hasNext() )
            {
                elIt = null;
            }
            Counter innerCount = new Counter( counter.getDepth() + 1 );
            while ( it.hasNext() )
            {
                Server value = (Server) it.next();
                Element el;
                if ( elIt != null && elIt.hasNext() )
                {
                    el = (Element) elIt.next();
                    if ( ! elIt.hasNext() )
                    {
                         elIt = null;
                    }
                }
                else
                {
                    el = factory.element( childTag, element.getNamespace() );
                    insertAtPreferredLocation( element, el, innerCount );
                }
                updateServer( value, childTag, innerCount, el );
                innerCount.increaseCount();
            }
            if ( elIt != null )
            {
                while ( elIt.hasNext() )
                {
                    elIt.next();
                    elIt.remove();
                }
            }
        }
    } //-- void iterateServer( Counter, Element, java.util.Collection, java.lang.String, java.lang.String )

    /**
     * Method replaceXpp3DOM.
     * 
     * @param parent
     * @param counter
     * @param parentDom
     */
    protected void replaceXpp3DOM( Element parent, Xpp3Dom parentDom, Counter counter )
    {
        if ( parentDom.getChildCount() > 0 )
        {
            Xpp3Dom[] childs = parentDom.getChildren();
            Collection domChilds = new ArrayList();
            for ( int i = 0; i < childs.length; i++ )
            {
                domChilds.add( childs[i] );
            }
            ListIterator it = parent.getChildren().listIterator();
            while ( it.hasNext() )
            {
                Element elem = (Element) it.next();
                Iterator it2 = domChilds.iterator();
                Xpp3Dom corrDom = null;
                while ( it2.hasNext() )
                {
                    Xpp3Dom dm = (Xpp3Dom) it2.next();
                    if ( dm.getName().equals( elem.getName() ) )
                    {
                        corrDom = dm;
                        break;
                    }
                }
                if ( corrDom != null )
                {
                    domChilds.remove( corrDom );
                    replaceXpp3DOM( elem, corrDom, new Counter( counter.getDepth() + 1 ) );
                    counter.increaseCount();
                }
                else
                {
                    it.remove();
                }
            }
            Iterator it2 = domChilds.iterator();
            while ( it2.hasNext() )
            {
                Xpp3Dom dm = (Xpp3Dom) it2.next();
                Element elem = factory.element( dm.getName(), parent.getNamespace() );
                insertAtPreferredLocation( parent, elem, counter );
                counter.increaseCount();
                replaceXpp3DOM( elem, dm, new Counter( counter.getDepth() + 1 ) );
            }
        }
         else if ( parentDom.getValue() != null )
        {
            parent.setText( parentDom.getValue() );
        }
    } //-- void replaceXpp3DOM( Element, Xpp3Dom, Counter )

    /**
     * Method updateActivation.
     * 
     * @param activation
     * @param element
     * @param counter
     * @param xmlTag
     */
    protected void updateActivation( Activation activation, String xmlTag, Counter counter, Element element )
    {
        boolean shouldExist = ( activation != null );
        Element root = updateElement( counter, element, xmlTag, shouldExist );
        if ( shouldExist )
        {
            Counter innerCount = new Counter( counter.getDepth() + 1 );
            findAndReplaceSimpleElement( innerCount, root, "activeByDefault", activation.isActiveByDefault() == false ? null : String.valueOf( activation.isActiveByDefault() ), "false" );
            findAndReplaceSimpleElement( innerCount, root, "jdk", activation.getJdk() == null ? null : activation.getJdk(), null );
            updateActivationOS( activation.getOs(), "os", innerCount, root );
            updateActivationProperty( activation.getProperty(), "property", innerCount, root );
            updateActivationFile( activation.getFile(), "file", innerCount, root );
        }
    } //-- void updateActivation( Activation, String, Counter, Element )

    /**
     * Method updateActivationFile.
     * 
     * @param activationFile
     * @param element
     * @param counter
     * @param xmlTag
     */
    protected void updateActivationFile( ActivationFile activationFile, String xmlTag, Counter counter, Element element )
    {
        boolean shouldExist = ( activationFile != null );
        Element root = updateElement( counter, element, xmlTag, shouldExist );
        if ( shouldExist )
        {
            Counter innerCount = new Counter( counter.getDepth() + 1 );
            findAndReplaceSimpleElement( innerCount, root, "missing", activationFile.getMissing() == null ? null : activationFile.getMissing(), null );
            findAndReplaceSimpleElement( innerCount, root, "exists", activationFile.getExists() == null ? null : activationFile.getExists(), null );
        }
    } //-- void updateActivationFile( ActivationFile, String, Counter, Element )

    /**
     * Method updateActivationOS.
     * 
     * @param activationOS
     * @param element
     * @param counter
     * @param xmlTag
     */
    protected void updateActivationOS( ActivationOS activationOS, String xmlTag, Counter counter, Element element )
    {
        boolean shouldExist = ( activationOS != null );
        Element root = updateElement( counter, element, xmlTag, shouldExist );
        if ( shouldExist )
        {
            Counter innerCount = new Counter( counter.getDepth() + 1 );
            findAndReplaceSimpleElement( innerCount, root, "name", activationOS.getName() == null ? null : activationOS.getName(), null );
            findAndReplaceSimpleElement( innerCount, root, "family", activationOS.getFamily() == null ? null : activationOS.getFamily(), null );
            findAndReplaceSimpleElement( innerCount, root, "arch", activationOS.getArch() == null ? null : activationOS.getArch(), null );
            findAndReplaceSimpleElement( innerCount, root, "version", activationOS.getVersion() == null ? null : activationOS.getVersion(), null );
        }
    } //-- void updateActivationOS( ActivationOS, String, Counter, Element )

    /**
     * Method updateActivationProperty.
     * 
     * @param activationProperty
     * @param element
     * @param counter
     * @param xmlTag
     */
    protected void updateActivationProperty( ActivationProperty activationProperty, String xmlTag, Counter counter, Element element )
    {
        boolean shouldExist = ( activationProperty != null );
        Element root = updateElement( counter, element, xmlTag, shouldExist );
        if ( shouldExist )
        {
            Counter innerCount = new Counter( counter.getDepth() + 1 );
            findAndReplaceSimpleElement( innerCount, root, "name", activationProperty.getName() == null ? null : activationProperty.getName(), null );
            findAndReplaceSimpleElement( innerCount, root, "value", activationProperty.getValue() == null ? null : activationProperty.getValue(), null );
        }
    } //-- void updateActivationProperty( ActivationProperty, String, Counter, Element )

    /**
     * Method updateElement.
     * 
     * @param counter
     * @param shouldExist
     * @param name
     * @param parent
     * @return Element
     */
    protected Element updateElement( Counter counter, Element parent, String name, boolean shouldExist )
    {
        Element element =  parent.getChild( name, parent.getNamespace() );
        if ( shouldExist )
        {
            if ( element == null )
            {
                element = factory.element( name, parent.getNamespace() );
                insertAtPreferredLocation( parent, element, counter );
            }
            counter.increaseCount();
        }
        else if ( element != null )
        {
            int index = parent.indexOf( element );
            if ( index > 0 )
            {
                Content previous = parent.getContent( index - 1 );
                if ( previous instanceof Text )
                {
                    Text txt = (Text) previous;
                    if ( txt.getTextTrim().length() == 0 )
                    {
                        parent.removeContent( txt );
                    }
                }
            }
            parent.removeContent( element );
        }
        return element;
    } //-- Element updateElement( Counter, Element, String, boolean )

    /**
     * Method updateIdentifiableBase.
     * 
     * @param identifiableBase
     * @param element
     * @param counter
     * @param xmlTag
     */
    protected void updateIdentifiableBase( IdentifiableBase identifiableBase, String xmlTag, Counter counter, Element element )
    {
        boolean shouldExist = ( identifiableBase != null );
        Element root = updateElement( counter, element, xmlTag, shouldExist );
        if ( shouldExist )
        {
            Counter innerCount = new Counter( counter.getDepth() + 1 );
            findAndReplaceSimpleElement( innerCount, root, "id", identifiableBase.getId() == null ? null : identifiableBase.getId(), "default" );
        }
    } //-- void updateIdentifiableBase( IdentifiableBase, String, Counter, Element )

    /**
     * Method updateMirror.
     * 
     * @param mirror
     * @param element
     * @param counter
     * @param xmlTag
     */
    protected void updateMirror( Mirror mirror, String xmlTag, Counter counter, Element element )
    {
        Element root = element;
        Counter innerCount = new Counter( counter.getDepth() + 1 );
        findAndReplaceSimpleElement( innerCount, root, "mirrorOf", mirror.getMirrorOf() == null ? null : mirror.getMirrorOf(), null );
        findAndReplaceSimpleElement( innerCount, root, "name", mirror.getName() == null ? null : mirror.getName(), null );
        findAndReplaceSimpleElement( innerCount, root, "url", mirror.getUrl() == null ? null : mirror.getUrl(), null );
        findAndReplaceSimpleElement( innerCount, root, "layout", mirror.getLayout() == null ? null : mirror.getLayout(), null );
        findAndReplaceSimpleElement( innerCount, root, "mirrorOfLayouts", mirror.getMirrorOfLayouts() == null ? null : mirror.getMirrorOfLayouts(), "default,legacy" );
        findAndReplaceSimpleElement( innerCount, root, "id", mirror.getId() == null ? null : mirror.getId(), "default" );
    } //-- void updateMirror( Mirror, String, Counter, Element )

    /**
     * Method updateProfile.
     * 
     * @param profile
     * @param element
     * @param counter
     * @param xmlTag
     */
    protected void updateProfile( Profile profile, String xmlTag, Counter counter, Element element )
    {
        Element root = element;
        Counter innerCount = new Counter( counter.getDepth() + 1 );
        updateActivation( profile.getActivation(), "activation", innerCount, root );
        findAndReplaceProperties( innerCount, root,  "properties", profile.getProperties() );
        iterateRepository( innerCount, root, profile.getRepositories(),"repositories","repository" );
        iterateRepository( innerCount, root, profile.getPluginRepositories(),"pluginRepositories","pluginRepository" );
        findAndReplaceSimpleElement( innerCount, root, "id", profile.getId() == null ? null : profile.getId(), "default" );
    } //-- void updateProfile( Profile, String, Counter, Element )

    /**
     * Method updateProxy.
     * 
     * @param proxy
     * @param element
     * @param counter
     * @param xmlTag
     */
    protected void updateProxy( Proxy proxy, String xmlTag, Counter counter, Element element )
    {
        Element root = element;
        Counter innerCount = new Counter( counter.getDepth() + 1 );
        findAndReplaceSimpleElement( innerCount, root, "active", proxy.isActive() == true ? null : String.valueOf( proxy.isActive() ), "true" );
        findAndReplaceSimpleElement( innerCount, root, "protocol", proxy.getProtocol() == null ? null : proxy.getProtocol(), "http" );
        findAndReplaceSimpleElement( innerCount, root, "username", proxy.getUsername() == null ? null : proxy.getUsername(), null );
        findAndReplaceSimpleElement( innerCount, root, "password", proxy.getPassword() == null ? null : proxy.getPassword(), null );
        findAndReplaceSimpleElement( innerCount, root, "port", proxy.getPort() == 8080 ? null : String.valueOf( proxy.getPort() ), "8080" );
        findAndReplaceSimpleElement( innerCount, root, "host", proxy.getHost() == null ? null : proxy.getHost(), null );
        findAndReplaceSimpleElement( innerCount, root, "nonProxyHosts", proxy.getNonProxyHosts() == null ? null : proxy.getNonProxyHosts(), null );
        findAndReplaceSimpleElement( innerCount, root, "id", proxy.getId() == null ? null : proxy.getId(), "default" );
    } //-- void updateProxy( Proxy, String, Counter, Element )

    /**
     * Method updateRepository.
     * 
     * @param repository
     * @param element
     * @param counter
     * @param xmlTag
     */
    protected void updateRepository( Repository repository, String xmlTag, Counter counter, Element element )
    {
        Element root = element;
        Counter innerCount = new Counter( counter.getDepth() + 1 );
        updateRepositoryPolicy( repository.getReleases(), "releases", innerCount, root );
        updateRepositoryPolicy( repository.getSnapshots(), "snapshots", innerCount, root );
        findAndReplaceSimpleElement( innerCount, root, "id", repository.getId() == null ? null : repository.getId(), null );
        findAndReplaceSimpleElement( innerCount, root, "name", repository.getName() == null ? null : repository.getName(), null );
        findAndReplaceSimpleElement( innerCount, root, "url", repository.getUrl() == null ? null : repository.getUrl(), null );
        findAndReplaceSimpleElement( innerCount, root, "layout", repository.getLayout() == null ? null : repository.getLayout(), "default" );
    } //-- void updateRepository( Repository, String, Counter, Element )

    /**
     * Method updateRepositoryBase.
     * 
     * @param repositoryBase
     * @param element
     * @param counter
     * @param xmlTag
     */
    protected void updateRepositoryBase( RepositoryBase repositoryBase, String xmlTag, Counter counter, Element element )
    {
        boolean shouldExist = ( repositoryBase != null );
        Element root = updateElement( counter, element, xmlTag, shouldExist );
        if ( shouldExist )
        {
            Counter innerCount = new Counter( counter.getDepth() + 1 );
            findAndReplaceSimpleElement( innerCount, root, "id", repositoryBase.getId() == null ? null : repositoryBase.getId(), null );
            findAndReplaceSimpleElement( innerCount, root, "name", repositoryBase.getName() == null ? null : repositoryBase.getName(), null );
            findAndReplaceSimpleElement( innerCount, root, "url", repositoryBase.getUrl() == null ? null : repositoryBase.getUrl(), null );
            findAndReplaceSimpleElement( innerCount, root, "layout", repositoryBase.getLayout() == null ? null : repositoryBase.getLayout(), "default" );
        }
    } //-- void updateRepositoryBase( RepositoryBase, String, Counter, Element )

    /**
     * Method updateRepositoryPolicy.
     * 
     * @param repositoryPolicy
     * @param element
     * @param counter
     * @param xmlTag
     */
    protected void updateRepositoryPolicy( RepositoryPolicy repositoryPolicy, String xmlTag, Counter counter, Element element )
    {
        boolean shouldExist = ( repositoryPolicy != null );
        Element root = updateElement( counter, element, xmlTag, shouldExist );
        if ( shouldExist )
        {
            Counter innerCount = new Counter( counter.getDepth() + 1 );
            findAndReplaceSimpleElement( innerCount, root, "enabled", repositoryPolicy.isEnabled() == true ? null : String.valueOf( repositoryPolicy.isEnabled() ), "true" );
            findAndReplaceSimpleElement( innerCount, root, "updatePolicy", repositoryPolicy.getUpdatePolicy() == null ? null : repositoryPolicy.getUpdatePolicy(), null );
            findAndReplaceSimpleElement( innerCount, root, "checksumPolicy", repositoryPolicy.getChecksumPolicy() == null ? null : repositoryPolicy.getChecksumPolicy(), null );
        }
    } //-- void updateRepositoryPolicy( RepositoryPolicy, String, Counter, Element )

    /**
     * Method updateServer.
     * 
     * @param server
     * @param element
     * @param counter
     * @param xmlTag
     */
    protected void updateServer( Server server, String xmlTag, Counter counter, Element element )
    {
        Element root = element;
        Counter innerCount = new Counter( counter.getDepth() + 1 );
        findAndReplaceSimpleElement( innerCount, root, "username", server.getUsername() == null ? null : server.getUsername(), null );
        findAndReplaceSimpleElement( innerCount, root, "password", server.getPassword() == null ? null : server.getPassword(), null );
        findAndReplaceSimpleElement( innerCount, root, "privateKey", server.getPrivateKey() == null ? null : server.getPrivateKey(), null );
        findAndReplaceSimpleElement( innerCount, root, "passphrase", server.getPassphrase() == null ? null : server.getPassphrase(), null );
        findAndReplaceSimpleElement( innerCount, root, "filePermissions", server.getFilePermissions() == null ? null : server.getFilePermissions(), null );
        findAndReplaceSimpleElement( innerCount, root, "directoryPermissions", server.getDirectoryPermissions() == null ? null : server.getDirectoryPermissions(), null );
        findAndReplaceXpp3DOM( innerCount, root, "configuration", (Xpp3Dom) server.getConfiguration() );
        findAndReplaceSimpleElement( innerCount, root, "id", server.getId() == null ? null : server.getId(), "default" );
    } //-- void updateServer( Server, String, Counter, Element )

    /**
     * Method updateSettings.
     * 
     * @param settings
     * @param element
     * @param counter
     * @param xmlTag
     */
    protected void updateSettings( Settings settings, String xmlTag, Counter counter, Element element )
    {
        Element root = element;
        Counter innerCount = new Counter( counter.getDepth() + 1 );
        findAndReplaceSimpleElement( innerCount, root, "localRepository", settings.getLocalRepository() == null ? null : settings.getLocalRepository(), null );
        findAndReplaceSimpleElement( innerCount, root, "interactiveMode", settings.isInteractiveMode() == true ? null : String.valueOf( settings.isInteractiveMode() ), "true" );
        findAndReplaceSimpleElement( innerCount, root, "usePluginRegistry", settings.isUsePluginRegistry() == false ? null : String.valueOf( settings.isUsePluginRegistry() ), "false" );
        findAndReplaceSimpleElement( innerCount, root, "offline", settings.isOffline() == false ? null : String.valueOf( settings.isOffline() ), "false" );
        iterateProxy( innerCount, root, settings.getProxies(),"proxies","proxy" );
        iterateServer( innerCount, root, settings.getServers(),"servers","server" );
        iterateMirror( innerCount, root, settings.getMirrors(),"mirrors","mirror" );
        iterateProfile( innerCount, root, settings.getProfiles(),"profiles","profile" );
        findAndReplaceSimpleLists( innerCount, root, settings.getActiveProfiles(), "activeProfiles", "activeProfile" );
        findAndReplaceSimpleLists( innerCount, root, settings.getPluginGroups(), "pluginGroups", "pluginGroup" );
    } //-- void updateSettings( Settings, String, Counter, Element )

    /**
     * Method updateTrackableBase.
     * 
     * @param trackableBase
     * @param element
     * @param counter
     * @param xmlTag
     */
    protected void updateTrackableBase( TrackableBase trackableBase, String xmlTag, Counter counter, Element element )
    {
        boolean shouldExist = ( trackableBase != null );
        Element root = updateElement( counter, element, xmlTag, shouldExist );
        if ( shouldExist )
        {
            Counter innerCount = new Counter( counter.getDepth() + 1 );
        }
    } //-- void updateTrackableBase( TrackableBase, String, Counter, Element )

    /**
     * Method write.
     * @deprecated
     * 
     * @param settings
     * @param stream
     * @param document
     * @throws java.io.IOException
     */
    public void write( Settings settings, Document document, OutputStream stream )
        throws java.io.IOException
    {
        updateSettings( settings, "settings", new Counter( 0 ), document.getRootElement() );
        XMLOutputter outputter = new XMLOutputter();
        outputter.setFormat( Format.getPrettyFormat()
            .setIndent( "    " )
            .setLineSeparator( System.getProperty( "line.separator" ) ) );
        outputter.output( document, stream );
    } //-- void write( Settings, Document, OutputStream )

    /**
     * Method write.
     * 
     * @param settings
     * @param writer
     * @param document
     * @throws java.io.IOException
     */
    public void write( Settings settings, Document document, OutputStreamWriter writer )
        throws java.io.IOException
    {
        Format format = Format.getRawFormat()
            .setEncoding( writer.getEncoding() )
            .setLineSeparator( System.getProperty( "line.separator" ) );
        write( settings, document, writer, format );
    } //-- void write( Settings, Document, OutputStreamWriter )

    /**
     * Method write.
     * 
     * @param settings
     * @param jdomFormat
     * @param writer
     * @param document
     * @throws java.io.IOException
     */
    public void write( Settings settings, Document document, Writer writer, Format jdomFormat )
        throws java.io.IOException
    {
        updateSettings( settings, "settings", new Counter( 0 ), document.getRootElement() );
        XMLOutputter outputter = new XMLOutputter();
        outputter.setFormat( jdomFormat );
        outputter.output( document, writer );
    } //-- void write( Settings, Document, Writer, Format )


      //-----------------/
     //- Inner Classes -/
    //-----------------/

    /**
     * Class Counter.
     * 
     * @version $Revision$ $Date$
     */
    public class Counter
    {

          //--------------------------/
         //- Class/Member Variables -/
        //--------------------------/

        /**
         * Field currentIndex.
         */
        private int currentIndex = 0;

        /**
         * Field level.
         */
        private int level;


          //----------------/
         //- Constructors -/
        //----------------/

        public Counter(int depthLevel)
        {
            level = depthLevel;
        } //-- org.apache.maven.settings.io.jdom.Counter(int)


          //-----------/
         //- Methods -/
        //-----------/

        /**
         * Method getCurrentIndex.
         * 
         * @return int
         */
        public int getCurrentIndex()
        {
            return currentIndex;
        } //-- int getCurrentIndex()

        /**
         * Method getDepth.
         * 
         * @return int
         */
        public int getDepth()
        {
            return level;
        } //-- int getDepth()

        /**
         * Method increaseCount.
         */
        public void increaseCount()
        {
            currentIndex = currentIndex + 1;
        } //-- void increaseCount()

    }

}
